; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include testwin.inc       ; local includes for this file

      select_win PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
      get_select_rect PROTO :DWORD,:DWORD

    .data?
      hSelect dd ?

    .code

start:

; 

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance,   FUNC(GetModuleHandle, NULL)
      mov CommandLine, FUNC(GetCommandLine)
      mov hIcon,       FUNC(LoadIcon,hInstance,500)
      mov hCursor,     FUNC(LoadCursor,NULL,IDC_ARROW)
      mov sWid,        FUNC(GetSystemMetrics,SM_CXSCREEN)
      mov sHgt,        FUNC(GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; 

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"DrawFocusRect_Class"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 75, 70

    invoke CreateWindowEx,WS_EX_LEFT,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayMenu hWnd,600
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; 

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; 

MsgLoop proc

    LOCAL msg:MSG

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

    mov eax, msg.wParam
    ret

MsgLoop endp

; 

WndProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL hDC    :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    Switch uMsg
      Case WM_COMMAND

        Switch wParam
        ;======== menu commands ========

          case 30000    ; WM_COMMAND message sent back from selection window

          ; -------------------------------------------------------------------------

            mov hDC, rv(GetDC,hSelect)
            invoke get_select_rect,hSelect,ADDR Rct

          ; ------------------------------------------------
          ; don't draw a rectangle smaller than 4 x 4 pixels
          ; ------------------------------------------------
            mov eax, Rct.right
            sub eax, 4
            cmp Rct.left, eax
            jle @F
            mov eax, Rct.bottom
            sub eax, 4
            cmp Rct.top, eax
            ret
          @@:

            mov var, ptr$(buffer1)
            mov var, cat$(var,str$(Rct.left)," ",str$(Rct.top)," ",str$(Rct.right)," ",str$(Rct.bottom))
            invoke SetWindowText,hWin,var

            invoke Rectangle,hDC,Rct.left,Rct.top,Rct.right,Rct.bottom
            invoke ReleaseDC,hSelect,hDC

          ; -------------------------------------------------------------------------

          Case 1010
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL

          Case 1900
            ShellAboutBox hWin,hIcon,\
              "About Selection Window Demo#Windows MASM32 Demo",\
              "Selection Window Demo",13,10,"Copyright  MASM32 1998-2005"

          ;====== end menu commands ======
      Endsw

      Case WM_CREATE

        invoke GetClientRect,hWin,ADDR Rct

        mov eax, Rct.left
        mov ecx, Rct.top
        sub Rct.right, eax
        sub Rct.bottom, ecx
        sub Rct.right, 20
        sub Rct.bottom, 40

        mov hSelect, rv(select_win,hWin,hInstance,10,10,Rct.right,Rct.bottom,30000)
        invoke SetClassLong,hSelect,GCL_HBRBACKGROUND,
                            rv(CreateSolidBrush,00FFAAAAh)      ; change background colour
        invoke SetClassLong,hSelect,GCL_HCURSOR,
                            rv(LoadCursor,NULL,IDC_CROSS)       ; change cursor

      Case WM_SYSCOLORCHANGE

      Case WM_SIZE

      Case WM_PAINT
        invoke Paint_Proc,hWin
        return 0

      Case WM_CLOSE

      Case WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0

    Endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; 

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; 

Paint_Proc proc hWin:DWORD

    LOCAL hDC      :DWORD
    LOCAL btn_hi   :DWORD
    LOCAL btn_lo   :DWORD
    LOCAL Rct      :RECT
    LOCAL Ps       :PAINTSTRUCT

    invoke BeginPaint,hWin,ADDR Ps
    mov hDC, eax

  ; ----------------------------------------

    invoke GetSysColor,COLOR_BTNHIGHLIGHT
    mov btn_hi, eax

    invoke GetSysColor,COLOR_BTNSHADOW
    mov btn_lo, eax

  ; ----------------------------------------

    invoke EndPaint,hWin,ADDR Ps

    ret

Paint_Proc endp

; 

select_win proc hParent:DWORD,instance:DWORD,
                tx:DWORD,ty:DWORD,wd:DWORD,ht:DWORD,IDnum:DWORD

    LOCAL hWin  :DWORD
    LOCAL pbuf  :DWORD
    LOCAL buffer[64]:BYTE
    LOCAL wc    :WNDCLASSEX

    mov pbuf, ptr$(buffer)

    mov wc.cbSize,        sizeof WNDCLASSEX
    mov wc.style,         CS_BYTEALIGNCLIENT or \
                          CS_BYTEALIGNWINDOW
    mov wc.lpfnWndProc,   OFFSET select_proc
    mov wc.cbClsExtra,    NULL
    mov wc.cbWndExtra,    36
    m2m wc.hInstance,     instance
    mov wc.hbrBackground, COLOR_WINDOW+1
    mov wc.lpszMenuName,  NULL
    mov wc.lpszClassName, cat$(pbuf,"sel_class_",str$(GetTickCount))   ; ensure unique class name
    mov wc.hIcon,         NULL
    mov wc.hCursor,       FUNC(LoadCursor,NULL,IDC_ARROW)
    mov wc.hIconSm,       NULL

    invoke RegisterClassEx, ADDR wc

    invoke CreateWindowEx,WS_EX_LEFT,
                          wc.lpszClassName,
                          NULL,
                          WS_BORDER or WS_CHILD,
                          tx,ty,wd,ht,
                          hParent,NULL,
                          instance,NULL
    mov hWin, eax
  ; --------------------------------------------------
  ; write the return message ID number to extra memory
  ; --------------------------------------------------
    invoke SetWindowLong,hWin,24,IDnum

    invoke ShowWindow,hWin,SW_SHOW
    mov eax, hWin

    ret

select_win endp

; 

select_proc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    LOCAL hDC       :DWORD
    LOCAL rct       :RECT

    switch uMsg

      case WM_LBUTTONDOWN
        movsx eax, WORD PTR [ebp+20]
        mov rct.left, eax
        movsx eax, WORD PTR [ebp+22]
        mov rct.top, eax

      ; -------------------------------------------------------------
      ; this pair can be modified in the following message processing
      ; -------------------------------------------------------------
        invoke SetWindowLong,hWin,0,rct.left
        invoke SetWindowLong,hWin,4,rct.top

      ; -----------------------------------
      ; this pair are the reference for the
      ; original mouse down co-ordinates
      ; -----------------------------------
        invoke SetWindowLong,hWin,16,rct.left
        invoke SetWindowLong,hWin,20,rct.top

        m2m rct.right, rct.left
        m2m rct.bottom, rct.top

        add rct.right, 1
        add rct.bottom, 1

        invoke SetWindowLong,hWin,8, rct.right
        invoke SetWindowLong,hWin,12,rct.bottom

        mov hDC, rv(GetDC,hWin)
        invoke DrawFocusRect,hDC,ADDR rct
        invoke ReleaseDC,hWin,hDC

    ; ====================================

      case WM_MOUSEMOVE
      .if wParam == MK_LBUTTON
        mov hDC, rv(GetDC,hWin)

        mov rct.left,   rv(GetWindowLong,hWin,0)
        mov rct.top,    rv(GetWindowLong,hWin,4)
        mov rct.right,  rv(GetWindowLong,hWin,8)
        mov rct.bottom, rv(GetWindowLong,hWin,12)

        invoke DrawFocusRect,hDC,ADDR rct

      ; -------------------------------------------------
      ; retrieve the reference pair of mouse co-ordinates
      ; -------------------------------------------------
        mov rct.left,   rv(GetWindowLong,hWin,16)
        mov rct.top,    rv(GetWindowLong,hWin,20)

      ; ----------------------------------
      ; get the current mouse co-ordinates
      ; ----------------------------------
        movsx eax, WORD PTR [ebp+20]
        mov rct.right, eax
        movsx eax, WORD PTR [ebp+22]
        mov rct.bottom, eax

        push ebx
        mov eax, rct.left
        mov ebx, rct.top
        mov ecx, rct.right
        mov edx, rct.bottom

        .if eax <= ecx && ebx <= edx
          mov rct.left, eax
          mov rct.top, ebx
          mov rct.right, ecx
          mov rct.bottom, edx
        .elseif eax >= ecx && ebx >= edx
          mov rct.left, ecx
          mov rct.top, edx
          mov rct.right, eax
          mov rct.bottom, ebx
        .elseif eax >= ecx && edx >= ebx
          mov rct.left, ecx
          mov rct.top, ebx
          mov rct.right, eax
          mov rct.bottom, edx
        .elseif eax <= ecx && edx <= ebx
          mov rct.left, eax
          mov rct.top, edx
          mov rct.right, ecx
          mov rct.bottom, ebx
        .endif

        pop ebx

        invoke DrawFocusRect,hDC,ADDR rct

        invoke SetWindowLong,hWin,0,rct.left
        invoke SetWindowLong,hWin,4,rct.top
        invoke SetWindowLong,hWin,8,rct.right
        invoke SetWindowLong,hWin,12,rct.bottom
        invoke ReleaseDC,hWin,hDC

      .endif

    ; ====================================

      case WM_LBUTTONUP
        mov hDC, rv(GetDC,hWin)
        mov rct.left,   rv(GetWindowLong,hWin,0)
        mov rct.top,    rv(GetWindowLong,hWin,4)
        mov rct.right,  rv(GetWindowLong,hWin,8)
        mov rct.bottom, rv(GetWindowLong,hWin,12)
        invoke DrawFocusRect,hDC,ADDR rct
        invoke ReleaseDC,hWin,hDC

      ; ---------------------------------------------------
      ; retrieve the ID number from extra memory and notify
      ; the parent window that the selection has been made.
      ; ---------------------------------------------------
        push esi
        mov esi, rv(GetWindowLong,hWin,24)
        invoke SendMessage,rv(GetParent,hWin),WM_COMMAND,esi,0
        pop esi

    endsw

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

select_proc endp

; 

get_select_rect proc hWin:DWORD,lprect:DWORD

    push esi

    mov esi, lprect
    mov (RECT PTR [esi]).left,   rv(GetWindowLong,hWin,0)
    mov (RECT PTR [esi]).top,    rv(GetWindowLong,hWin,4)
    mov (RECT PTR [esi]).right,  rv(GetWindowLong,hWin,8)
    mov (RECT PTR [esi]).bottom, rv(GetWindowLong,hWin,12)

    pop esi

    ret

get_select_rect endp

; 

end start
